/*
 * Main.java
 *
 * Created on 3  2005 ., 9:54
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

import	java.applet.Applet;
import	java.awt.*;
import  java.util.Calendar;
import	java.awt.event.WindowListener;
import	java.awt.event.WindowEvent;

/**
 *
 * @author scalan
 */
public class Main extends Applet
    implements Runnable, WindowListener {

    private int r = 0;

    Thread		m_Thread = null;
    private	boolean	m_isStandalone = false;
    public	boolean	isStandalone(){return m_isStandalone;}
    
    /** Creates a new instance of Main */
    public Main() {
    }

    public void init(){
        if(getWidth()<getHeight()) r = getWidth()/2; else r = getHeight()/2;
        r-=5;
    }
    
    public void paint( Graphics g ){
        //  ...
        g.setColor(new Color(128, 128, 128));
        g.fillRect(0, 0, getWidth(), getHeight());
        //  ...
        for(int i=0; i<60; i++){
            int x = getWidth()/2 - 2 + getSin100(i*360/60) * r / 100;
            int y = getHeight()/2- 2 - getCos100(i*360/60) * r / 100;
            if(i%5==0){ 
                g.setColor(new Color(255, 10, 10));
                g.fillArc(x-2, y-2, 8, 8, 0, 360);
            }
            else{
                g.setColor(new Color(0, 0, 0));
                g.fillArc(x, y, 4, 4, 0, 360);
            }
        }
        //   ...
        g.setColor(new Color(0, 0, 0));
        g.fillArc(getWidth()/2-8, getHeight()/2-8, 16, 16, 0, 360);

        //  ...
        Calendar currentCalendar = Calendar.getInstance();
        
        int	hour = currentCalendar.get(currentCalendar.HOUR)+3;
        int	min  = currentCalendar.get(currentCalendar.MINUTE);
        int	sec  = currentCalendar.get(currentCalendar.SECOND);
        if( hour > 12 )	hour -= 12;

        int	hour_radius= 75 * r / 100;
        int	min_radius = 85 * r / 100;
        int	sec_radius = 95 * r / 100;

        //---   ---
        g.setColor(new Color(0, 0, 32));
        g.drawLine(
            getWidth()/2 + getSin100(hour * 360/12) * hour_radius / 100,
            getHeight()/2 - getCos100(hour * 360/12) * hour_radius / 100, 
            getWidth()/2, 
            getHeight()/2
        );

        //---   ---
        g.setColor(new Color(0, 0, 128));
        g.drawLine(
            getWidth()/2 + getSin100(min * 360/60) * min_radius / 100,
            getHeight()/2 - getCos100(min * 360/60) * min_radius / 100, 
            getWidth()/2, 
            getHeight()/2
        );

        //---   ---
        g.setColor(new Color(0, 0, 255));
        g.drawLine(
            getWidth()/2 + getSin100(sec * 360/60)*sec_radius / 100,
            getHeight()/2 - getCos100(sec * 360/60)*sec_radius / 100, 
            getWidth()/2, 
            getHeight()/2
        );
    }

    public void start() {
        m_Thread = new Thread(this);
        m_Thread.start();
    }

    public void stop(){
        m_Thread.stop();
        m_Thread = null;
    }

    public void Close() {
        m_work = false;
    }
    
    long        oldtime = 0;
    boolean     m_work	= true;

    public void run() {
        long	time = System.currentTimeMillis();
        m_work = true;
        while( m_work ){
            repaint();
            try{
                Thread.currentThread().sleep( 300 );
            }
            catch(InterruptedException ex) {}
        }
    }
    
    public String getAppletInfo() {
        return "Title: A simple clock.";
    }
    
    public	void	windowActivated( WindowEvent evt ) {
    }
    
    public	void	windowClosing( WindowEvent evt ) {
        if( isStandalone() ) {
            m_work = false;
            try	{
                Thread.currentThread().sleep( 500 );
            }
            catch( InterruptedException e ){
            }
            System.exit( 0 );
        }
    }

    public	void	windowClosed( WindowEvent evt ) {
    }

    public	void	windowDeactivated( WindowEvent evt ) {
    }
    
    public	void	windowDeiconified( WindowEvent evt ) {
    }

    public	void	windowIconified( WindowEvent evt ) {
    }

    public	void	windowOpened( WindowEvent evt ) {
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        Frame	frame = new Frame();
        frame.setLayout( new BorderLayout() );
        frame.setBounds( 100,100, 200,200 );
        Main	clock = new Main();
        clock.setBounds( 0,0,200,200 );
        frame.add( clock, "Center" );
        frame.addWindowListener( clock );

        frame.setTitle( "Simple clock" );
        frame.setVisible( true );
        clock.setVisible( true );

        clock.m_isStandalone = true;
        clock.init();

        clock.start();
    }
    
    public static int getSin100(int a){
        byte Values[] = {
            0, 1, 3, 5, 6, 8, 10, 12, 13, 15, 17, 19, 20, 22, 24, 25, 27, 29, 
            30, 32, 34, 35, 37, 39, 40, 42, 43, 45, 46, 48, 49, 51, 52, 54, 55, 57, 
            58, 60, 61, 62, 64, 65, 66, 68, 69, 70, 71, 73, 74, 75, 76, 77, 78, 79, 
            80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 89, 90, 91, 92, 92, 93, 93, 94, 
            95, 95, 96, 96, 97, 97, 97, 98, 98, 98, 99, 99, 99, 99, 99, 99, 99, 99, 
            100, 99, 99, 99, 99, 99, 99, 99, 99, 98, 98, 98, 97, 97, 97, 96, 96, 95, 
            95, 94, 93, 93, 92, 92, 91, 90, 89, 89, 88, 87, 86, 85, 84, 83, 82, 81, 
            80, 79, 78, 77, 76, 75, 74, 73, 71, 70, 69, 68, 66, 65, 64, 62, 61, 60, 
            58, 57, 55, 54, 52, 51, 49, 48, 46, 45, 43, 42, 40, 39, 37, 35, 34, 32, 
            30, 29, 27, 25, 24, 22, 20, 19, 17, 15, 13, 12, 10, 8, 6, 5, 3, 1, 
            0, -1, -3, -5, -6, -8, -10, -12, -13, -15, -17, -19, -20, -22, -24, -25, -27, -29, 
            -30, -32, -34, -35, -37, -39, -40, -42, -43, -45, -46, -48, -50, -51, -52, -54, -55, -57, 
            -58, -60, -61, -62, -64, -65, -66, -68, -69, -70, -71, -73, -74, -75, -76, -77, -78, -79, 
            -80, -81, -82, -83, -84, -85, -86, -87, -88, -89, -89, -90, -91, -92, -92, -93, -93, -94, 
            -95, -95, -96, -96, -97, -97, -97, -98, -98, -98, -99, -99, -99, -99, -99, -99, -99, -99, 
            -100, -99, -99, -99, -99, -99, -99, -99, -99, -98, -98, -98, -97, -97, -97, -96, -96, -95, 
            -95, -94, -93, -93, -92, -92, -91, -90, -89, -89, -88, -87, -86, -85, -84, -83, -82, -81, 
            -80, -79, -78, -77, -76, -75, -74, -73, -71, -70, -69, -68, -66, -65, -64, -62, -61, -60, 
            -58, -57, -55, -54, -52, -51, -50, -48, -46, -45, -43, -42, -40, -39, -37, -35, -34, -32, 
            -30, -29, -27, -25, -24, -22, -20, -19, -17, -15, -13, -12, -10, -8, -6, -5, -3, -1
        };
        return Values[a%360];
    }

    public static int getCos100(int a){
        byte Values[] = {
            100, 99, 99, 99, 99, 99, 99, 99, 99, 98, 98, 98, 97, 97, 97, 96, 96, 95, 
            95, 94, 93, 93, 92, 92, 91, 90, 89, 89, 88, 87, 86, 85, 84, 83, 82, 81, 
            80, 79, 78, 77, 76, 75, 74, 73, 71, 70, 69, 68, 66, 65, 64, 62, 61, 60, 
            58, 57, 55, 54, 52, 51, 50, 48, 46, 45, 43, 42, 40, 39, 37, 35, 34, 32, 
            30, 29, 27, 25, 24, 22, 20, 19, 17, 15, 13, 12, 10, 8, 6, 5, 3, 1, 
            0, -1, -3, -5, -6, -8, -10, -12, -13, -15, -17, -19, -20, -22, -24, -25, -27, -29, 
            -30, -32, -34, -35, -37, -39, -40, -42, -43, -45, -46, -48, -49, -51, -52, -54, -55, -57, 
            -58, -60, -61, -62, -64, -65, -66, -68, -69, -70, -71, -73, -74, -75, -76, -77, -78, -79, 
            -80, -81, -82, -83, -84, -85, -86, -87, -88, -89, -89, -90, -91, -92, -92, -93, -93, -94, 
            -95, -95, -96, -96, -97, -97, -97, -98, -98, -98, -99, -99, -99, -99, -99, -99, -99, -99, 
            -100, -99, -99, -99, -99, -99, -99, -99, -99, -98, -98, -98, -97, -97, -97, -96, -96, -95, 
            -95, -94, -93, -93, -92, -92, -91, -90, -89, -89, -88, -87, -86, -85, -84, -83, -82, -81, 
            -80, -79, -78, -77, -76, -75, -74, -73, -71, -70, -69, -68, -66, -65, -64, -62, -61, -60, 
            -58, -57, -55, -54, -52, -51, -50, -48, -46, -45, -43, -42, -40, -39, -37, -35, -34, -32, 
            -30, -29, -27, -25, -24, -22, -20, -19, -17, -15, -13, -12, -10, -8, -6, -5, -3, -1, 
            0, 1, 3, 5, 6, 8, 10, 12, 13, 15, 17, 19, 20, 22, 24, 25, 27, 29, 
            30, 32, 34, 35, 37, 39, 40, 42, 43, 45, 46, 48, 50, 51, 52, 54, 55, 57, 
            58, 60, 61, 62, 64, 65, 66, 68, 69, 70, 71, 73, 74, 75, 76, 77, 78, 79, 
            80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 89, 90, 91, 92, 92, 93, 93, 94, 
            95, 95, 96, 96, 97, 97, 97, 98, 98, 98, 99, 99, 99, 99, 99, 99, 99, 99
        };
        return Values[a%360];
    }
}
